import type { Extension } from "@codemirror/state";
import { type RecorderPlugin, ReplayDataRecorder } from "@liqvid/recording";
import type { ReplayData } from "@liqvid/utils/replay-data";
import { scrollCmd } from ".";
export type EditorChange = [
    [
        number,
        ...(EditorChange | number | string)[]
    ],
    [
        number,
        number
    ]
];
export type SpecialKey = string;
export type ScrollAction = [typeof scrollCmd, number, number] | [typeof scrollCmd, number];
export type CaptureData = EditorChange | ScrollAction | SpecialKey;
export declare class CodeRecorder extends ReplayDataRecorder<CaptureData> {
    constructor();
    /**
     * Get a CodeMirror extension for recording.
     * @param specialKeys Map of key sequences to commands, e.g. {"Mod-Enter": "run"}.
     * @returns CodeMirror extension.
     */
    extension(specialKeys?: Record<string, string> | string[]): Extension;
}
export declare const CodeRecording: RecorderPlugin<[
    number,
    CaptureData
], ReplayData<CaptureData>, CodeRecorder>;
